"use strict";exports.formatSeconds = formatSeconds;exports.formatDate = formatDate;exports.textToSeconds = textToSeconds;exports.timeSinceDate = timeSinceDate;Object.defineProperty(exports, "__esModule", {value:true});"use strict";function formatSeconds(seconds, format, param){if(seconds === null || isNaN(seconds)){return "";}param = param || {};seconds = parseInt(seconds, 10);format = format || "%h:%M:%S";var format_no_days=param.format_no_days || format, format_no_hours=param.format_no_hours || format_no_days, format_no_minutes=param.format_no_minutes, exclude_days=param.exclude_days || false;var values={};values.d = Math.floor(seconds / 86400);values.h = exclude_days?Math.floor(seconds / 3600):Math.floor(seconds / 3600) % 24;values.m = Math.floor(seconds / 60) % 60;values.s = seconds % 60;values.H = values.h < 10?"0" + values.h:values.h;values.M = values.m < 10?"0" + values.m:values.m;values.S = values.s < 10?"0" + values.s:values.s;if(0 === values.d){if(0 === values.h){format = format_no_hours;}else {format = format_no_days;}}if(0 === values.m && (values.h > 0 || values.days > 0) && format_no_minutes){format = format_no_minutes;}Object.keys(values).forEach(function(placeholder){var value=values[placeholder];format = format.replace("%" + placeholder, value);});return format;}function formatDate(date, format){var twoDigits=function twoDigits(num){if(num < 10){return "0" + num;}return num;};var hours=date.getHours();var period="AM";if(hours == 0){hours = 12;}else if(hours > 12){hours -= 12;period = "PM";}var monthName=function monthName(index, length){var months=["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];if(length > 3){return months[index];}else {return months[index].substring(0, length);}};var dayName=function dayName(index, length){var days=["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];if(length > 3){return days[index];}else {return days[index].substring(0, length);}};var symbols=[{regex:/(y{4}|y{2})/g, value:function(match, p1, offset, string){if(match.length === 2){return date.getFullYear() % 100;}else {return date.getFullYear();}}}, {regex:/(M{1,5})/g, value:function(match, p1, offset, string){switch(match.length){case 1:return date.getMonth() + 1;case 2:return twoDigits(date.getMonth() + 1);default:return monthName(date.getMonth(), match.length);}}}, {regex:/(E{3,6})/g, value:function(match, p1, offset, string){switch(match.length){case 5:return dayName(date.getDay(), 1);case 6:return dayName(date.getDay(), 2);default:return dayName(date.getDay(), match.length);}}}, {regex:/(d{1,2})/g, value:function(match, p1, offset, string){switch(match.length){case 1:return date.getDate();case 2:return twoDigits(date.getDate());}}}, {regex:/(a)/g, value:function(match, p1, offset, string){return period;}}, {regex:/(h{1,2})/g, value:function(match, p1, offset, string){switch(match.length){case 1:return hours;case 2:return twoDigits(hours);}}}, {regex:/(H{1,2})/g, value:function(match, p1, offset, string){switch(match.length){case 1:return date.getHours();case 2:return twoDigits(date.getHours());}}}, {regex:/(m{1,2})/g, value:function(match, p1, offset, string){switch(match.length){case 1:return date.getMinutes();case 2:return twoDigits(date.getMinutes());}}}, {regex:/(s{1,2})/g, value:function(match, p1, offset, string){switch(match.length){case 1:return date.getSeconds();case 2:return twoDigits(date.getSeconds());}}}];var checkFormat=format.replace(/['"].*?['"]/, function(match){var replacement="";for(var i=0; i < match.length; i++) {replacement += "%";}return replacement;});var replacements=[];symbols.forEach(function(symbol){var exec=symbol.regex.exec(checkFormat);if(exec){symbol.execIndex = exec.index;replacements.push(symbol);}});replacements.sort(function(a, b){return b.execIndex - a.execIndex;});var formatted=format;replacements.forEach(function(symbol){formatted = formatted.replace(symbol.regex, function(match, p1, offset, string){if(symbol.execIndex == offset){return symbol.value(match, p1, offset, string);}else {return match;}});});formatted = formatted.replace(/['"]/g, "");return formatted;}function textToSeconds(string){var seconds=0;if(string.match(/^(\d+|\d+\.\d+)$/)){seconds += string * 60;}else if(string.match(/:/)){var time_split=string.split(":");if(time_split.length >= 2){seconds += parseInt(time_split[0], 10) * 3600;seconds += parseInt(time_split[1], 10) * 60;if(time_split.length == 3){seconds += parseInt(time_split[2], 10);}}else {alert("Invalid time entry");}}else {var time_array=string.match(/(?:(\d+|\d+\.\d+)d\s*)?(?:(\d+|\d+\.\d+)h\s*)?(?:(\d+|\d+\.\d+)m\s*)?(?:(\d+|\d+\.\d+)s)?/);if(time_array[1] !== undefined){seconds += time_array[1] * 28800;}if(time_array[2] !== undefined){seconds += time_array[2] * 3600;}if(time_array[3] !== undefined){seconds += time_array[3] * 60;}if(time_array[4] !== undefined){seconds += parseInt(time_array[4], 10);}}return seconds;}function timeSinceDate(date){var hoursOnly=arguments[1] === undefined?true:arguments[1];var deltaSeconds=(new Date().getTime() - date.getTime()) / 1000;if(deltaSeconds < 0){deltaSeconds = 0;}var deltaMinutes=Math.floor(deltaSeconds / 60);if(deltaMinutes < 30){return "Just Now";}else {var deltaHours=Math.round(deltaMinutes / 60);if(deltaHours < 24){return "" + deltaHours + "h ago";}else {if(hoursOnly){return formatDate(date, "EEE MMM d yyyy");}else {var deltaDays=Math.round(deltaHours / 24);return "" + deltaDays + "d ago";}}}}
//# sourceMappingURL=datetime.js.map