"use strict";var _interopRequire=function(obj){return obj && obj.__esModule?obj["default"]:obj;};var _interopRequireWildcard=function(obj){return obj && obj.__esModule?obj:{"default":obj};};var _get=function get(object, property, receiver){var desc=Object.getOwnPropertyDescriptor(object, property);if(desc === undefined){var parent=Object.getPrototypeOf(object);if(parent === null){return undefined;}else {return get(parent, property, receiver);}}else if("value" in desc && desc.writable){return desc.value;}else {var getter=desc.get;if(getter === undefined){return undefined;}return getter.call(receiver);}};var _inherits=function(subClass, superClass){if(typeof superClass !== "function" && superClass !== null){throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, {constructor:{value:subClass, enumerable:false, writable:true, configurable:true}});if(superClass)subClass.__proto__ = superClass;};var _createClass=(function(){function defineProperties(target, props){for(var key in props) {var prop=props[key];prop.configurable = true;if(prop.value)prop.writable = true;}Object.defineProperties(target, props);}return function(Constructor, protoProps, staticProps){if(protoProps)defineProperties(Constructor.prototype, protoProps);if(staticProps)defineProperties(Constructor, staticProps);return Constructor;};})();var _classCallCheck=function(instance, Constructor){if(!(instance instanceof Constructor)){throw new TypeError("Cannot call a class as a function");}};exports.httpMonitor = httpMonitor;exports.initAPIHTTP = initAPIHTTP;exports.authorizeAPIHTTP = authorizeAPIHTTP;exports.refreshAPIToken = refreshAPIToken;exports._authorizeAPIHTTPFromResponse = _authorizeAPIHTTPFromResponse;exports.alhttp = alhttp;exports.apihttp = apihttp;Object.defineProperty(exports, "__esModule", {value:true});"use strict";var AL=_interopRequireWildcard(require("./affinity"));var Deployment=_interopRequire(require("./model/deployment"));var Staff=_interopRequire(require("./model/staff"));var UserDefinedTitles=_interopRequire(require("./model/user_defined_titles"));var ALNotification=_interopRequireWildcard(require("./al-notification"));var _XMLHttpRequest=undefined;if(typeof window === "undefined"){_XMLHttpRequest = require("xhr2");}else {_XMLHttpRequest = XMLHttpRequest;}var HTTPMonitor=exports.HTTPMonitor = (function(){function HTTPMonitor(){_classCallCheck(this, HTTPMonitor);this.requestCount = 0;}_createClass(HTTPMonitor, {requestStarted:{value:function requestStarted(){this.requestCount++;}}, _requestFinished:{value:function _requestFinished(){if(this.requestCount > 0){this.requestCount--;}}}, requestSucceeded:{value:function requestSucceeded(response){this._requestFinished();}}, requestFailed:{value:function requestFailed(response, reportError){this._requestFinished();var error=response.getError();if(reportError && ALNotification.notificationCenter()){var notification=new ALNotification.ErrorNotification("Request Failed.", error);notification.show();}}}});return HTTPMonitor;})();function httpMonitor(){if(!AL.AFFINITY().httpMonitor){AL.AFFINITY().httpMonitor = new HTTPMonitor();}return AL.AFFINITY().httpMonitor;}var HTTP=exports.HTTP = (function(){function HTTP(baseUrl){_classCallCheck(this, HTTP);if(baseUrl){var url=baseUrl;if(url.charAt(url.length - 1) != "/"){url += "/";}this._baseUrl = url;}else {this._baseUrl = null;}}_createClass(HTTP, {disableAutomaticErrorReporting:{value:function disableAutomaticErrorReporting(){this._disableAutomaticErrorReporting = true;}}, get:{value:function get(url){var params=arguments[1] === undefined?{}:arguments[1];var headers=arguments[2] === undefined?{}:arguments[2];var options=arguments[3] === undefined?{}:arguments[3];return this._request(url, "GET", params, headers, options);}}, post:{value:function post(url){var params=arguments[1] === undefined?{}:arguments[1];var headers=arguments[2] === undefined?{}:arguments[2];var options=arguments[3] === undefined?{}:arguments[3];return this._request(url, "POST", params, headers, options);}}, put:{value:function put(url){var params=arguments[1] === undefined?{}:arguments[1];var headers=arguments[2] === undefined?{}:arguments[2];var options=arguments[3] === undefined?{}:arguments[3];return this._request(url, "PUT", params, headers, options);}}, "delete":{value:function _delete(url){var params=arguments[1] === undefined?{}:arguments[1];var headers=arguments[2] === undefined?{}:arguments[2];var options=arguments[3] === undefined?{}:arguments[3];return this._request(url, "DELETE", params, headers, options);}}, _request:{value:function _request(url){var _this=this;var method=arguments[1] === undefined?"GET":arguments[1];var params=arguments[2] === undefined?{}:arguments[2];var headers=arguments[3] === undefined?{}:arguments[3];var options=arguments[4] === undefined?{}:arguments[4];var request=this._setupXHR(url, method, params, headers, options);var promise=new Promise(function(resolve, reject){request.onload = function(){_this._requestCompleted(request, resolve, reject);};request.onerror = function(){_this._requestCompleted(request, resolve, reject);};httpMonitor().requestStarted();if(request._alhttpBody){request.send(request._alhttpBody);}else {request.send();}});promise.xhr = request;return promise;}}, _setupXHR:{value:function _setupXHR(url){var method=arguments[1] === undefined?"GET":arguments[1];var params=arguments[2] === undefined?{}:arguments[2];var headers=arguments[3] === undefined?{}:arguments[3];var options=arguments[4] === undefined?{}:arguments[4];if(this._baseUrl){if(url.charAt(0) == "/"){url = url.substr(1);}url = this._baseUrl + url;}var body=null;switch(method){case "GET":case "PUT":if(Object.keys(params).length){url += "?" + this._serializeQueryParams(params);}break;case "POST":case "DELETE":if(!headers["Content-Type"]){headers["Content-Type"] = "application/x-www-form-urlencoded";}switch(headers["Content-Type"]){case "application/x-www-form-urlencoded":body = this._serializeQueryParams(params);break;default:throw new Error("Unknown content type: " + headers["Content-Type"]);}break;default:throw new Error("Invalid request method \"" + method + "\"");}var request=new _XMLHttpRequest();request.open(method, url);for(var header in headers) {request.setRequestHeader(header, headers[header]);}if(body){request._alhttpBody = body;}return request;}}, _serializeQueryParams:{value:function _serializeQueryParams(params){var queryValues=[];for(var key in params) {var value=params[key];var queryValue=null;if(value instanceof Array){queryValue = value.join(",");}else {queryValue = value;}if(queryValue){var queryComponent=encodeURIComponent(key) + "=" + encodeURIComponent(queryValue);queryValues.push(queryComponent);}}var queryString=queryValues.join("&");return queryString;}}, _requestCompleted:{value:function _requestCompleted(request, resolve, reject){var response=this._parseResponse(request);if(response.wasSuccessful()){httpMonitor().requestSucceeded(response);resolve(response);}else {httpMonitor().requestFailed(response, !this._disableAutomaticErrorReporting);reject(response);}}}, _parseResponse:{value:function _parseResponse(request){return new HTTPResponse(request);}}});return HTTP;})();var HTTPResponse=exports.HTTPResponse = (function(){function HTTPResponse(request){_classCallCheck(this, HTTPResponse);this._request = request;this._parseResponseStatus();this._parseResponseHeaders();this._parseResponseText();}_createClass(HTTPResponse, {wasSuccessful:{value:function wasSuccessful(){return this._success;}}, getError:{value:function getError(){return this._error;}}, getResponseHeaders:{value:function getResponseHeaders(){return this._responseHeaders;}}, getResponseHeader:{value:function getResponseHeader(header){if(this._responseHeaders[header]){return this._responseHeaders[header];}else {return null;}}}, getResponse:{value:function getResponse(){return this._response;}}, getRequest:{value:function getRequest(){return this._request;}}, _parseResponseStatus:{value:function _parseResponseStatus(){var statusCodeString=this._request.status.toString();var responseURL=this._request.responseURL;if(statusCodeString.match(/2/) || typeof this._request.responseURL !== "undefined" && this._request.responseURL.match(/^file:\/\//)){this._success = true;this._error = null;}else {this._success = false;if(this._request.status === 0){this._error = new Error("There was a problem communicating with the server. Please check your network connection. If you are using an adblocker, please add an exception or allow pages from your deployment's Affinitylive domain and refresh the page.");}else if(statusCodeString.match(/^4/)){this._error = new Error("There was a problem making a request to the server.");}else if(statusCodeString.match(/^5/)){this._error = new Error("The server encountered an error while processing the request.");}else {this._error = new Error("An error occurred while communicating with the server.");}}}}, _parseResponseHeaders:{value:function _parseResponseHeaders(){var headers={};var headerString=this._request.getAllResponseHeaders();if(typeof headerString === "string" && headerString.length !== 0){var headerPairs=headerString.split("\r\n");headerPairs.forEach(function(headerPair, i){var index=headerPair.indexOf(": ");if(index > 0){var key=headerPair.substring(0, index);var val=headerPair.substring(index + 2);headers[key] = val;}});}this._responseHeaders = headers;}}, _parseResponseText:{value:function _parseResponseText(){var responseType=null;var contentType=this.getResponseHeader("Content-Type") || this.getResponseHeader("content-type");if(contentType){var contentTypeParts=contentType.split(/;/);responseType = contentTypeParts[0];}else {responseType = "text/plain";}var response=null;switch(responseType){case "text/json":case "application/json":try{response = JSON.parse(this._request.responseText);}catch(err) {console.error(err);this._success = false;this._error = err;response = null;}break;case "text/plain":case "text/css":response = this._request.responseText;break;default:console.warn("Unknown response type: " + responseType);}if(typeof response === "string" && response.length == 0){response = null;}this._response = response;}}});return HTTPResponse;})();var ALHTTP=exports.ALHTTP = (function(_HTTP){function ALHTTP(){_classCallCheck(this, ALHTTP);var baseUrl="/api/0.5/key";_get(Object.getPrototypeOf(ALHTTP.prototype), "constructor", this).call(this, baseUrl);}_inherits(ALHTTP, _HTTP);_createClass(ALHTTP, {_request:{value:function _request(url){var method=arguments[1] === undefined?"GET":arguments[1];var params=arguments[2] === undefined?{}:arguments[2];var headers=arguments[3] === undefined?{}:arguments[3];var options=arguments[4] === undefined?{}:arguments[4];if(typeof window.api_key !== "undefined"){headers["X-API-Key"] = window.api_key;}return _get(Object.getPrototypeOf(ALHTTP.prototype), "_request", this).call(this, url, method, params, headers, options);}}, _parseResponse:{value:function _parseResponse(request){var response=new ALHTTPResponse(request);return response;}}});return ALHTTP;})(HTTP);var ALHTTPResponse=exports.ALHTTPResponse = (function(_HTTPResponse){function ALHTTPResponse(){_classCallCheck(this, ALHTTPResponse);if(_HTTPResponse != null){_HTTPResponse.apply(this, arguments);}}_inherits(ALHTTPResponse, _HTTPResponse);_createClass(ALHTTPResponse, {getResponseMeta:{value:function getResponseMeta(){return this._responseMeta;}}, _parseResponseText:{value:function _parseResponseText(){_get(Object.getPrototypeOf(ALHTTPResponse.prototype), "_parseResponseText", this).call(this);if(this._response && typeof this._response === "object"){if(this._response.hasOwnProperty("meta") && this._response.hasOwnProperty("response")){this._responseMeta = this._response.meta;this._response = this._response.response;}else {this._responseMeta = null;}}}}});return ALHTTPResponse;})(HTTPResponse);var APIHTTP=exports.APIHTTP = (function(_HTTP2){function APIHTTP(deployment, oauthToken){var domain=arguments[2] === undefined?"affinitylive.com":arguments[2];var options=arguments[3] === undefined?{}:arguments[3];_classCallCheck(this, APIHTTP);var baseUrl="https://" + deployment + ".api." + domain + "/api/v0/private/mobile";_get(Object.getPrototypeOf(APIHTTP.prototype), "constructor", this).call(this, baseUrl);this._oauthToken = oauthToken;if(options.logoutCallback && typeof options.logoutCallback === "function"){this._logoutCallback = options.logoutCallback;}}_inherits(APIHTTP, _HTTP2);_createClass(APIHTTP, {setLogoutCallback:{value:function setLogoutCallback(callback){this._logoutCallback = callback;}}, _request:{value:function _request(url){var method=arguments[1] === undefined?"GET":arguments[1];var params=arguments[2] === undefined?{}:arguments[2];var headers=arguments[3] === undefined?{}:arguments[3];var options=arguments[4] === undefined?{}:arguments[4];headers.Authorization = "Bearer " + this._oauthToken;headers["Accept-Type"] = "application/json";return _get(Object.getPrototypeOf(APIHTTP.prototype), "_request", this).call(this, url, method, params, headers, options);}}, _requestCompleted:{value:function _requestCompleted(request, resolve, reject){if(request.status == 401){if(this._logoutCallback){this._logoutCallback();}}_get(Object.getPrototypeOf(APIHTTP.prototype), "_requestCompleted", this).call(this, request, resolve, reject);}}, _parseResponse:{value:function _parseResponse(request){var response=new APIHTTPResponse(request);if(response.getRequest().status == 401){if(this._logoutCallback){this._logoutCallback();}}return response;}}});return APIHTTP;})(HTTP);var APIHTTPResponse=exports.APIHTTPResponse = (function(_HTTPResponse2){function APIHTTPResponse(){_classCallCheck(this, APIHTTPResponse);if(_HTTPResponse2 != null){_HTTPResponse2.apply(this, arguments);}}_inherits(APIHTTPResponse, _HTTPResponse2);_createClass(APIHTTPResponse, {getResponseMeta:{value:function getResponseMeta(){return this._responseMeta;}}, _parseResponseText:{value:function _parseResponseText(){_get(Object.getPrototypeOf(APIHTTPResponse.prototype), "_parseResponseText", this).call(this);if(this._response && typeof this._response === "object"){if(this._response.meta){this._responseMeta = this._response.meta;}else {this._responseMeta = null;}if(this._response.response){this._response = this._response.response;}else {this._response = null;}}}}});return APIHTTPResponse;})(HTTPResponse);function initAPIHTTP(deployment, token, domain, options){AL.AFFINITY().apihttp = new APIHTTP(deployment, token, domain, options);}function authorizeAPIHTTP(deployment, domain, code, clientId, clientSecret){return new Promise(function(resolve, reject){var http=new HTTP();var url="https://" + deployment + ".api." + domain + "/oauth2/v0/token";http.post(url, {grant_type:"authorization_code", code:code}, {"Content-Type":"application/x-www-form-urlencoded", Authorization:"Basic " + btoa("" + clientId + ":" + clientSecret)}).then(function(httpResponse){var response=httpResponse.getResponse();if(response && _authorizeAPIHTTPFromResponse(response, domain)){resolve(response);}else {var error=new Error("Authorization was unsuccessful.");if(ALNotification.notificationCenter()){var notification=new ALNotification.ErrorNotification("Authorization Failed", error);notification.show();}reject(error);}})["catch"](function(httpResponse){reject(httpResponse.getError());});});}function refreshAPIToken(deployment, domain, refreshToken, clientId, clientSecret){return new Promise(function(resolve, reject){var http=new HTTP();var url="https://" + deployment + ".api." + domain + "/oauth2/v0/token";http.post(url, {grant_type:"refresh_token", code:refreshToken}, {"Content-Type":"application/x-www-form-urlencoded", Authorization:"Basic " + btoa("" + clientId + ":" + clientSecret)}).then(function(httpResponse){var response=httpResponse.getResponse();_authorizeAPIHTTPFromResponse(response, domain);resolve(response);})["catch"](function(httpResponse){reject(new Error("Unable to reauthorize."));});});}function _authorizeAPIHTTPFromResponse(response, domain){if(!response.account_details){return false;}var accountDetails=JSON.parse(JSON.stringify(response.account_details));var deployment=new Deployment({deployment:response.deployment, deployment_uri:response.deployment_uri, deployment_name:response.deployment_name, locale:accountDetails.locale, user_access:accountDetails.user_access, user_defined_titles:accountDetails.user_defined_titles});AL._setAPIDeployment(deployment);var userDefinedTitles=new UserDefinedTitles(accountDetails.user_defined_titles);AL._setUserDefinedTitles(userDefinedTitles);delete accountDetails.locale;delete accountDetails.user_access;delete accountDetails.user_defined_titles;delete accountDetails.initials;var staff=new Staff(accountDetails);AL._setAPIUser(staff);var accessToken=response.access_token;var refreshToken=response.refresh_token;var deploymentPrefix=response.deployment;initAPIHTTP(deploymentPrefix, accessToken, domain);return true;}function alhttp(){if(!AL.AFFINITY().alhttp){AL.AFFINITY().alhttp = new ALHTTP();}return AL.AFFINITY().alhttp;}function apihttp(){if(!AL.AFFINITY().apihttp){throw new Error("You must initialise the API HTTP using initAPIHTTP before using it.");}return AL.AFFINITY().apihttp;}
//# sourceMappingURL=http.js.map