"use strict";var _interopRequire=function(obj){return obj && obj.__esModule?obj["default"]:obj;};var _get=function get(object, property, receiver){var desc=Object.getOwnPropertyDescriptor(object, property);if(desc === undefined){var parent=Object.getPrototypeOf(object);if(parent === null){return undefined;}else {return get(parent, property, receiver);}}else if("value" in desc && desc.writable){return desc.value;}else {var getter=desc.get;if(getter === undefined){return undefined;}return getter.call(receiver);}};var _inherits=function(subClass, superClass){if(typeof superClass !== "function" && superClass !== null){throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, {constructor:{value:subClass, enumerable:false, writable:true, configurable:true}});if(superClass)subClass.__proto__ = superClass;};var _createClass=(function(){function defineProperties(target, props){for(var key in props) {var prop=props[key];prop.configurable = true;if(prop.value)prop.writable = true;}Object.defineProperties(target, props);}return function(Constructor, protoProps, staticProps){if(protoProps)defineProperties(Constructor.prototype, protoProps);if(staticProps)defineProperties(Constructor, staticProps);return Constructor;};})();var _classCallCheck=function(instance, Constructor){if(!(instance instanceof Constructor)){throw new TypeError("Cannot call a class as a function");}};Object.defineProperty(exports, "__esModule", {value:true});"use strict";var apihttp=require("../http").apihttp;var ALRelatedObjectManager=_interopRequire(require("./related_objects"));var HTTPPaginator=exports.HTTPPaginator = (function(){function HTTPPaginator(url, alhttp){var requestParams=arguments[2] === undefined?{}:arguments[2];var options=arguments[3] === undefined?{}:arguments[3];_classCallCheck(this, HTTPPaginator);this._url = url;this._alhttp = alhttp;this._requestParams = requestParams;this._requestMethod = options.requestMethod || "GET";this._itemsPerPage = options.itemsPerPage || 10;this._modelClass = options.modelClass || null;this._relatedObjectConfig = options.relatedObjectConfig || null;if(options.loadPageCallback){this._loadPageCallback = options.loadPageCallback;}else {throw new Error("HTTPPaginator created without a loadPageCallback specified");}this._clearCallback = options.clearCallback || null;if(options.loadErrorCallback){this._loadErrorCallback = options.loadErrorCallback;}else {this._loadErrorCallback = null;throw new Error("HTTPPaginator created without a loadErrorCallback specified");}this._results = [];this._hasMoreData = true;this._currentPage = -1;if(options.responseKey){this._responseKey = options.responseKey;}else {this._responseKey = null;}}_createClass(HTTPPaginator, {reload:{value:function reload(){this._clear();this.loadNextPage();}}, loadNextPage:{value:function loadNextPage(){this._performRequestForPage(this._currentPage + 1);}}, updateResults:{value:function updateResults(results){var pages=arguments[1] === undefined?null:arguments[1];var hasMoreData=arguments[2] === undefined?true:arguments[2];this._results = results;if(pages){this._currentPage = pages - 1;}else {this._currentPage = Math.ceil(results / this._itemsPerPage);}this._hasMoreData = hasMoreData;}}, _clear:{value:function _clear(){this.cancelCurrentRequest();this._results.length = 0;this._hasMoreData = true;this._currentPage = -1;if(this._clearCallback){this._clearCallback();}}}, _performRequestForPage:{value:function _performRequestForPage(page){var _this=this;if(!this._currentRequest && this._hasMoreData){var params=this._setupRequestParamsForPage(page);var promise=this._alhttp._request(this._url, this._requestMethod, params);this._currentRequest = promise.xhr;promise.then(function(httpResponse){_this._currentPage = page;_this._currentRequest = null;var response=httpResponse.getResponse();_this._processRelatedObjects(httpResponse);_this._processResponse(response);}, function(response){_this._currentRequest = null;if(_this._loadErrorCallback){_this._loadErrorCallback(response);}});}}}, _setupRequestParamsForPage:{value:function _setupRequestParamsForPage(page){return Object.assign({_page:page, _limit:this._itemsPerPage}, this._requestParams);}}, _processResponse:{value:function _processResponse(response){var newItems=this._processResponseItems(response);if(typeof response.has_more_data !== "undefined"){this._hasMoreData = !!response.has_more_data;}else if(newItems.length < this._itemsPerPage){this._hasMoreData = false;}Array.prototype.push.apply(this._results, newItems);this._loadPageCallback(newItems);}}, _processResponseItems:{value:function _processResponseItems(response){var _this=this;var responseItemArray=undefined;if(this._responseKey){responseItemArray = response[this._responseKey];}else {responseItemArray = response;}var newItems=[];if(responseItemArray){var doProcessResponseItem=undefined;if(this._modelClass){doProcessResponseItem = function(object){return new _this._modelClass(object);};}else {doProcessResponseItem = function(object){return object;};}var _iteratorNormalCompletion=true;var _didIteratorError=false;var _iteratorError=undefined;try{for(var _iterator=responseItemArray[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {var responseItem=_step.value;newItems.push(doProcessResponseItem(responseItem));}}catch(err) {_didIteratorError = true;_iteratorError = err;}finally {try{if(!_iteratorNormalCompletion && _iterator["return"]){_iterator["return"]();}}finally {if(_didIteratorError){throw _iteratorError;}}}}return newItems;}}, _processRelatedObjects:{value:function _processRelatedObjects(response){if(this._relatedObjectConfig){var responseKey=this._relatedObjectConfig.responseKey;var table=this._relatedObjectConfig.table;ALRelatedObjectManager().parseObjectsFromResponse(response, responseKey, table);}}}, cancelCurrentRequest:{value:function cancelCurrentRequest(){if(this.requestInProgress()){this._currentRequest.abort();this._currentRequest = null;}}}, hasMoreData:{value:function hasMoreData(){return this._hasMoreData;}}, requestInProgress:{value:function requestInProgress(){return !!this._currentRequest;}}, allResults:{value:function allResults(){return this._results;}}, setRequestParam:{value:function setRequestParam(key, value){var clear=arguments[2] === undefined?true:arguments[2];if(value === null || typeof value === "undefined"){if(this._requestParams[key]){delete this._requestParams[key];}}else {this._requestParams[key] = value;}if(clear){this._clear();}}}, requestParams:{value:function requestParams(){return this._requestParams;}}});return HTTPPaginator;})();var APIPaginator=exports.APIPaginator = (function(_HTTPPaginator){function APIPaginator(endpoint){var requestParams=arguments[1] === undefined?{}:arguments[1];var options=arguments[2] === undefined?{}:arguments[2];_classCallCheck(this, APIPaginator);_get(Object.getPrototypeOf(APIPaginator.prototype), "constructor", this).call(this, endpoint, apihttp(), requestParams, options);if(options.filters){this.setFilters(options.filters);}if(options.search){this.setSearch(options.search);}if(options.fields){this.setFields(options.fields);}}_inherits(APIPaginator, _HTTPPaginator);_createClass(APIPaginator, {setFilters:{value:function setFilters(filters){this.setRequestParam("_filters", filters);}}, setSearch:{value:function setSearch(searchTerm){if(searchTerm.length == 0){this.setRequestParam("_search", null);}else {this.setRequestParam("_search", searchTerm);}}}, setFields:{value:function setFields(fields){this.setRequestParam("_fields", fields);}}});return APIPaginator;})(HTTPPaginator);
//# sourceMappingURL=pagination.js.map