"use strict";var _interopRequireWildcard=function(obj){return obj && obj.__esModule?obj:{"default":obj};};var _interopRequire=function(obj){return obj && obj.__esModule?obj["default"]:obj;};var _createClass=(function(){function defineProperties(target, props){for(var key in props) {var prop=props[key];prop.configurable = true;if(prop.value)prop.writable = true;}Object.defineProperties(target, props);}return function(Constructor, protoProps, staticProps){if(protoProps)defineProperties(Constructor.prototype, protoProps);if(staticProps)defineProperties(Constructor, staticProps);return Constructor;};})();var _get=function get(object, property, receiver){var desc=Object.getOwnPropertyDescriptor(object, property);if(desc === undefined){var parent=Object.getPrototypeOf(object);if(parent === null){return undefined;}else {return get(parent, property, receiver);}}else if("value" in desc && desc.writable){return desc.value;}else {var getter=desc.get;if(getter === undefined){return undefined;}return getter.call(receiver);}};var _inherits=function(subClass, superClass){if(typeof superClass !== "function" && superClass !== null){throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, {constructor:{value:subClass, enumerable:false, writable:true, configurable:true}});if(superClass)subClass.__proto__ = superClass;};var _classCallCheck=function(instance, Constructor){if(!(instance instanceof Constructor)){throw new TypeError("Cannot call a class as a function");}};var _model=require("../model");var Model=_interopRequire(_model);var ModelValueTypes=_model.ModelValueTypes;var AL=_interopRequireWildcard(require("../affinity"));var ALDateTime=_interopRequireWildcard(require("../affinity/datetime"));var ActivityInteract=_interopRequire(require("./activity/interact"));var Attachment=_interopRequire(require("./attachment"));var Class=_interopRequire(require("./class"));var Priority=_interopRequire(require("./priority"));var Tag=_interopRequire(require("./tag"));var Activity=(function(_Model){function Activity(){_classCallCheck(this, Activity);if(_Model != null){_Model.apply(this, arguments);}}_inherits(Activity, _Model);_createClass(Activity, {_objectKeyConfiguration:{value:function _objectKeyConfiguration(){var paths=_get(Object.getPrototypeOf(Activity.prototype), "_objectKeyConfiguration", this).call(this);return Object.assign(paths, {parentId:{type:ModelValueTypes.NUMBER, key:"parent_id", "default":0}, threadId:{type:ModelValueTypes.NUMBER, key:"thread_id"}, subject:{type:ModelValueTypes.STRING}, body:{type:ModelValueTypes.STRING}, interacts:{type:ModelValueTypes.ARRAY(ModelValueTypes.MODEL(ActivityInteract)), "default":[]}, billableTime:{type:ModelValueTypes.NUMBER, key:"billabletime"}, nonbillableTime:{type:ModelValueTypes.NUMBER, key:"nonbillabletime"}, visibility:{type:ModelValueTypes.STRING}, priority:{type:ModelValueTypes.MODEL(Priority)}, "class":{type:ModelValueTypes.MODEL(Class)}, tags:{type:ModelValueTypes.ARRAY(ModelValueTypes.MODEL(Tag))}, medium:{type:ModelValueTypes.STRING}, details:{type:ModelValueTypes.STRING}, ownerId:{type:ModelValueTypes.NUMBER, key:"owner_id"}, ownerType:{type:ModelValueTypes.STRING, key:["owner_table", "owner_type"]}, againstId:{type:ModelValueTypes.NUMBER, key:"against_id"}, againstType:{type:ModelValueTypes.STRING, key:"against_type"}, dateCreated:{type:ModelValueTypes.DATE, key:"date_created"}, dateStarted:{type:ModelValueTypes.DATE, key:"date_started"}, dateEnded:{type:ModelValueTypes.DATE, key:"date_ended"}, dateDue:{type:ModelValueTypes.DATE, key:"date_due"}, dateUpdated:{type:ModelValueTypes.DATE, key:"date_updated"}, dateLogged:{type:ModelValueTypes.DATE, key:"date_logged"}, attachments:{type:ModelValueTypes.ARRAY(ModelValueTypes.MODEL(Attachment)), "default":[]}});}}, billableTimeString:{value:function billableTimeString(){var billableTime=this.get("billableTime");if(billableTime){return ALDateTime.formatSeconds(billableTime, "%hh %mm", {format_no_hours:"%mm", exclude_days:true});}return "";}}, _timeSinceDate:{value:function _timeSinceDate(field){var date=this.get(field);if(date){return ALDateTime.timeSinceDate(date);}return "";}}, timeSinceDateLogged:{value:function timeSinceDateLogged(){return this._timeSinceDate("dateLogged");}}, timeSinceDateCreated:{value:function timeSinceDateCreated(){return this._timeSinceDate("dateCreated");}}, _formattedDate:{value:function _formattedDate(field, format){var date=this.get(field);if(date){return ALDateTime.formatDate(date, format);}return "";}}, formattedLoggedDate:{value:function formattedLoggedDate(){return this._formattedDate("dateLogged", "EEE MMM d, yyyy 'at' h:mm a");}}, formattedCreatedDate:{value:function formattedCreatedDate(){return this._formattedDate("dateCreated", "EEE MMM d yyyy");}}, meetingDateStrings:{value:function meetingDateStrings(){var started=this.get("dateStarted");var ended=this.get("dateEnded");if(started && ended){var startedDate=ALDateTime.formatDate(started, "EEEE d MMMM");var endedDate=ALDateTime.formatDate(ended, "EEEE d MMMM");if(startedDate === endedDate){return [startedDate];}else {return [startedDate, endedDate];}}return [];}}, meetingTimeStrings:{value:function meetingTimeStrings(){var started=this.get("dateStarted");var ended=this.get("dateEnded");if(started && ended){var startedTime=ALDateTime.formatDate(started, "h:mm a");var endedTime=ALDateTime.formatDate(ended, "h:mm a");return [startedTime, endedTime];}return [];}}, _calculateInteractCategories:{value:function _calculateInteractCategories(){var _this=this;this._interacts = {interactTypes:{}, fromInteract:null, recipientInteracts:[], replyAllInteracts:[], replyTeamInteracts:[]};var addReplyInteract=function(interact){if(interact.get("ownerTable") == "staff"){if(interact.get("ownerId") != AL.getUser().get("id")){_this._interacts.replyAllInteracts.push(interact);_this._interacts.replyTeamInteracts.push(interact);}}else {_this._interacts.replyAllInteracts.push(interact);}};var sortOrder=["to", "attendee", "attended", "cc"];var primaryInteractType=undefined;if(this.get("ownerType") === "staff"){primaryInteractType = "affiliation";}else {primaryInteractType = "staff";}var allInteracts=this.get("interacts");allInteracts.sort(function(a, b){var aType=a.get("type");var bType=b.get("type");if(aType === bType){var aTable=a.get("ownerTable");var bTable=b.get("ownerTable");if(aTable === bTable){return 0;}else if(aTable === primaryInteractType){return -1;}else {return 1;}}else {var aTypeIndex=sortOrder.indexOf(aType);if(aTypeIndex === -1){aTypeIndex = sortOrder.length;}var bTypeIndex=sortOrder.indexOf(bType);if(bTypeIndex === -1){bTypeIndex = sortOrder.length;}return aTypeIndex < bTypeIndex?-1:1;}});allInteracts.forEach(function(interact, i){var type=interact.get("type");if(type === "attended"){type = "attendee";}if(_this.get("ownerId") === interact.get("ownerId") && _this.get("ownerType") === interact.get("ownerTable")){_this._interacts.fromInteract = interact;}if(type != "bcc"){if(!_this._interacts.interactTypes[type]){_this._interacts.interactTypes[type] = [];}_this._interacts.interactTypes[type].push(interact);addReplyInteract(interact);switch(type){case "to":case "cc":_this._interacts.recipientInteracts.push(interact);break;case "attendee":_this._interacts.recipientInteracts.push(interact);break;}}});}}, interactTypes:{value:function interactTypes(){if(!this._interacts){this._calculateInteractCategories();}return this._interacts.interactTypes;}}, interactType:{value:function interactType(type){var interactTypes=this.interactTypes();if(interactTypes){return interactTypes[type];}return null;}}, fromInteract:{value:function fromInteract(){if(!this._interacts){this._calculateInteractCategories();}return this._interacts.fromInteract;}}, recipientInteracts:{value:function recipientInteracts(){if(!this._interacts){this._calculateInteractCategories();}return this._interacts.recipientInteracts;}}, replyInteracts:{value:function replyInteracts(){if(!this._interacts){this._calculateInteractCategories();}if(this._interacts.fromInteract){return [this._interacts.fromInteract];}else {return [];}}}, replyAllInteracts:{value:function replyAllInteracts(){if(!this._interacts){this._calculateInteractCategories();}return this._interacts.replyAllInteracts;}}, replyTeamInteracts:{value:function replyTeamInteracts(){if(!this._interacts){this._calculateInteractCategories();}return this._interacts.replyTeamInteracts;}}, isConfidentialActivity:{value:function isConfidentialActivity(){return this.get("visibility") === "confidential" && this.get("id") === 0;}}});return Activity;})(Model);module.exports = Activity;
//# sourceMappingURL=activity.js.map