"use strict";var _interopRequireWildcard=function(obj){return obj && obj.__esModule?obj:{"default":obj};};var _interopRequire=function(obj){return obj && obj.__esModule?obj["default"]:obj;};var _createClass=(function(){function defineProperties(target, props){for(var key in props) {var prop=props[key];prop.configurable = true;if(prop.value)prop.writable = true;}Object.defineProperties(target, props);}return function(Constructor, protoProps, staticProps){if(protoProps)defineProperties(Constructor.prototype, protoProps);if(staticProps)defineProperties(Constructor, staticProps);return Constructor;};})();var _get=function get(object, property, receiver){var desc=Object.getOwnPropertyDescriptor(object, property);if(desc === undefined){var parent=Object.getPrototypeOf(object);if(parent === null){return undefined;}else {return get(parent, property, receiver);}}else if("value" in desc && desc.writable){return desc.value;}else {var getter=desc.get;if(getter === undefined){return undefined;}return getter.call(receiver);}};var _inherits=function(subClass, superClass){if(typeof superClass !== "function" && superClass !== null){throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);}subClass.prototype = Object.create(superClass && superClass.prototype, {constructor:{value:subClass, enumerable:false, writable:true, configurable:true}});if(superClass)subClass.__proto__ = superClass;};var _classCallCheck=function(instance, Constructor){if(!(instance instanceof Constructor)){throw new TypeError("Cannot call a class as a function");}};Object.defineProperty(exports, "__esModule", {value:true});"use strict";var _model=require("../model");var Model=_interopRequire(_model);var ModelValueTypes=_model.ModelValueTypes;var ALDateTime=_interopRequireWildcard(require("../affinity/datetime"));var ALRelatedObjectManager=_interopRequire(require("../http/related_objects"));var ActivityThread=_interopRequire(require("./activity/thread"));var Breadcrumb=_interopRequire(require("./breadcrumb"));var Status=_interopRequire(require("./status"));var getNextUniqueIndentifier=(function(){var _nextId=1;return function(){return _nextId++;};})();var TimelineEntry=(function(_Model){function TimelineEntry(){_classCallCheck(this, TimelineEntry);if(_Model != null){_Model.apply(this, arguments);}}_inherits(TimelineEntry, _Model);_createClass(TimelineEntry, {_objectKeyConfiguration:{value:function _objectKeyConfiguration(){var paths=_get(Object.getPrototypeOf(TimelineEntry.prototype), "_objectKeyConfiguration", this).call(this);return Object.assign(paths, {title:{type:ModelValueTypes.STRING, key:"entry_title"}, actionedDate:{type:ModelValueTypes.DATE, key:"entry_actioned_date"}, actions:{type:ModelValueTypes.ARRAY(ModelValueTypes.MODEL(TimelineEntryAction)), key:"entry_actions"}, actionedBy:{type:ModelValueTypes.MODEL(TimelineEntryPerson), key:"entry_actioned_by"}, activityThread:{type:ModelValueTypes.MODEL(ActivityThread), key:"entry_activity_thread"}, object:{type:ModelValueTypes.MODEL(TimelineEntryObject), key:"entry_object"}, objectMetadata:{type:ModelValueTypes.ARRAY(ModelValueTypes.MODEL(TimelineEntryMetadataObject)), key:"entry_object_metadata"}});}}, _parseKeyValue:{value:function _parseKeyValue(key, value){var useDefault=arguments[2] === undefined?false:arguments[2];if(key === "activityThread" && typeof value === "object" && Object.keys(value).length === 0){return _get(Object.getPrototypeOf(TimelineEntry.prototype), "_parseKeyValue", this).call(this, key, null, useDefault);}else {return _get(Object.getPrototypeOf(TimelineEntry.prototype), "_parseKeyValue", this).call(this, key, value, useDefault);}}}, getTimeSinceActioned:{value:function getTimeSinceActioned(){var actionedDate=this.get("actionedDate");if(actionedDate){return ALDateTime.timeSinceDate(actionedDate);}else {return "";}}}, getIdentifier:{value:function getIdentifier(){if(!this._uniqueIdentifier){this._uniqueIdentifier = getNextUniqueIndentifier();}return this._uniqueIdentifier;}}});return TimelineEntry;})(Model);exports["default"] = TimelineEntry;var TimelineEntryAction=exports.TimelineEntryAction = (function(_Model2){function TimelineEntryAction(){_classCallCheck(this, TimelineEntryAction);if(_Model2 != null){_Model2.apply(this, arguments);}}_inherits(TimelineEntryAction, _Model2);_createClass(TimelineEntryAction, {_objectKeyConfiguration:{value:function _objectKeyConfiguration(){var paths=_get(Object.getPrototypeOf(TimelineEntryAction.prototype), "_objectKeyConfiguration", this).call(this);return Object.assign(paths, {action:{type:ModelValueTypes.STRING}, changes:{type:ModelValueTypes.ARRAY(ModelValueTypes.MODEL(TimelineEntryActionChange))}, entryId:{type:ModelValueTypes.NUMBER, key:"timeline_entry_id"}});}}});return TimelineEntryAction;})(Model);var TimelineEntryActionChange=exports.TimelineEntryActionChange = (function(_Model3){function TimelineEntryActionChange(){_classCallCheck(this, TimelineEntryActionChange);if(_Model3 != null){_Model3.apply(this, arguments);}}_inherits(TimelineEntryActionChange, _Model3);_createClass(TimelineEntryActionChange, {_objectKeyConfiguration:{value:function _objectKeyConfiguration(){var paths=_get(Object.getPrototypeOf(TimelineEntryActionChange.prototype), "_objectKeyConfiguration", this).call(this);return Object.assign(paths, {field:{type:ModelValueTypes.STRING}, table:{type:ModelValueTypes.STRING}, type:{type:ModelValueTypes.STRING}, from:{type:ModelValueTypes.STRING, key:"from_value"}, to:{type:ModelValueTypes.STRING, key:"to_value"}, actionId:{type:ModelValueTypes.NUMBER, key:"action_id"}});}}, fromObject:{value:function fromObject(){if(!this._fromObject){this._fromObject = ALRelatedObjectManager().getObject(this.get("table"), this.get("from"));}return this._fromObject;}}, toObject:{value:function toObject(){if(!this._toObject){this._toObject = ALRelatedObjectManager().getObject(this.get("table"), this.get("to"));}return this._toObject;}}});return TimelineEntryActionChange;})(Model);var TimelineEntryPerson=exports.TimelineEntryPerson = (function(_Model4){function TimelineEntryPerson(){_classCallCheck(this, TimelineEntryPerson);if(_Model4 != null){_Model4.apply(this, arguments);}}_inherits(TimelineEntryPerson, _Model4);_createClass(TimelineEntryPerson, {_objectKeyConfiguration:{value:function _objectKeyConfiguration(){var paths=_get(Object.getPrototypeOf(TimelineEntryPerson.prototype), "_objectKeyConfiguration", this).call(this);return Object.assign(paths, {table:{type:ModelValueTypes.STRING}, name:{type:ModelValueTypes.STRING}});}}});return TimelineEntryPerson;})(Model);var TimelineEntryObject=exports.TimelineEntryObject = (function(_Model5){function TimelineEntryObject(){_classCallCheck(this, TimelineEntryObject);if(_Model5 != null){_Model5.apply(this, arguments);}}_inherits(TimelineEntryObject, _Model5);_createClass(TimelineEntryObject, {_objectKeyConfiguration:{value:function _objectKeyConfiguration(){var paths=_get(Object.getPrototypeOf(TimelineEntryObject.prototype), "_objectKeyConfiguration", this).call(this);return Object.assign(paths, {table:{type:ModelValueTypes.STRING}, name:{type:ModelValueTypes.STRING}, status:{type:ModelValueTypes.MODEL(Status)}, breadcrumbs:{type:ModelValueTypes.ARRAY(ModelValueTypes.MODEL(Breadcrumb))}});}}});return TimelineEntryObject;})(Model);var TimelineEntryMetadataObject=exports.TimelineEntryMetadataObject = (function(_Model6){function TimelineEntryMetadataObject(){_classCallCheck(this, TimelineEntryMetadataObject);if(_Model6 != null){_Model6.apply(this, arguments);}}_inherits(TimelineEntryMetadataObject, _Model6);_createClass(TimelineEntryMetadataObject, {_objectKeyConfiguration:{value:function _objectKeyConfiguration(){var paths=_get(Object.getPrototypeOf(TimelineEntryMetadataObject.prototype), "_objectKeyConfiguration", this).call(this);return Object.assign(paths, {title:{type:ModelValueTypes.STRING}, type:{type:ModelValueTypes.STRING}, table:{type:ModelValueTypes.STRING}, value:{type:ModelValueTypes.STRING}, ids:{type:ModelValueTypes.ARRAY(ModelValueTypes.STRING)}});}}, object:{value:function object(){if(!this._relatedObject){this._relatedObject = ALRelatedObjectManager().getObject(this.get("table"), this.get("id"));}return this._relatedObject;}}, objects:{value:function objects(){var _this=this;if(!this._relatedObjects){this._relatedObjects = [];var ids=this.get("ids") || [this.get("id")];ids.forEach(function(id, index){_this._relatedObjects.push(ALRelatedObjectManager().getObject(_this.get("table"), id));});}return this._relatedObjects;}}, dateTimeString:{value:function dateTimeString(){var value=this.get("value");if(value){var date=new Date(value);if(!isNaN(date.getTime())){return ALDateTime.formatDate(date, "EEE MMM d, yyyy 'at' h:mm a");}}return null;}}});return TimelineEntryMetadataObject;})(Model);
//# sourceMappingURL=timeline_entry.js.map